@echo off
set COB_LIBRARY_PATH=.;%COB_LIBRARY_PATH%
echo EXTENSIONS TEST GROUP
copy nul prog.empty > nul

echo COMP-5
copy /y extensions.1 dump.c > nul
cl /LD dump.c > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.2 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.3 result
if errorlevel 1 goto err

echo Hexadecimal numeric literal
copy /y extensions.4 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.5 result
if errorlevel 1 goto err

echo Semi-parenthesized condition
copy /y extensions.6 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.7 result
if errorlevel 1 goto err

echo ADDRESS OF
copy /y extensions.8 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.9 result
if errorlevel 1 goto err

echo LENGTH OF
copy /y extensions.10 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.11 result
if errorlevel 1 goto err

echo WHEN-COMPILED
copy /y extensions.12 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.13 result
if errorlevel 1 goto err

echo Complex OCCURS DEPENDING ON
copy /y extensions.14 prog.cob > nul
cobc -x -debug -Wall -std=mvs -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.15 result
if errorlevel 1 goto err

echo MOVE NON-INTEGER TO ALPHA-NUMERIC
copy /y extensions.16 prog.cob > nul
cobc -C -x -debug -Wall -std=mf prog.cob > result 2>&1
if errorlevel 1 goto err
diff extensions.17 result
if errorlevel 1 goto err
cobc -x -debug -Wall -std=mf prog.c > result 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.18 result
if errorlevel 1 goto err

echo CALL USING file-name
copy /y extensions.19 setfilename.c > nul
cobc -m -debug -Wall -std=cobol2002 setfilename.c > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.20 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff prog.empty result
if errorlevel 1 goto err
if not exist TESTFILE goto err
del TESTFILE setfilename.*

echo CALL unusual PROGRAM-ID.
copy /y extensions.21 A@B.cob > nul
cobc -m -debug -Wall -std=cobol2002 A@B.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.22 A#B.cob > nul
cobc -m -debug -Wall -std=cobol2002 A#B.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.23 A-B.cob > nul
cobc -m -debug -Wall -std=cobol2002 A-B.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.24 A_B.cob > nul
cobc -m -debug -Wall -std=cobol2002 A_B.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.25 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o caller caller.cob > comp.out 2>&1
if errorlevel 1 goto err
caller > result
if errorlevel 1 goto err
diff extensions.57 result
if errorlevel 1 goto err
del A?B.*

echo Case independent PROGRAM-ID
copy /y extensions.58 prog.cob > nul
cobc -x -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.7 result
if errorlevel 1 goto err

echo PROGRAM-ID AS clause
copy /y extensions.59 prog.cob > nul
cobc -x -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.7 result
if errorlevel 1 goto err

echo Quoted PROGRAM-ID
copy /y extensions.60 prog.cob > nul
cobc -x -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.7 result
if errorlevel 1 goto err

echo ASSIGN MF
copy /y extensions.26 test.conf > nul
copy /y extensions.27 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff prog.empty result
if errorlevel 1 goto err

echo ASSIGN IBM
copy /y extensions.28 test.conf > nul
copy /y extensions.29 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff prog.empty result
if errorlevel 1 goto err
if not exist FILENAME goto err
del FILENAME

echo ASSIGN mapping
copy /y extensions.30 test.conf > nul
copy /y extensions.31 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
set DD_FILENAME=x
prog
if errorlevel 1 goto err
if not exist x goto err
set DD_FILENAME=
set dd_FILENAME=y
prog
if errorlevel 1 goto err
if not exist y goto err
set dd_FILENAME=
set FILENAME=z
prog
if errorlevel 1 goto err
if not exist z goto err
set FILENAME=
prog
if errorlevel 1 goto err
if not exist FILENAME goto err
del FILENAME x y z

echo ASSIGN expansion
copy /y extensions.32 test.conf > nul
copy /y extensions.33 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
mkdir XXX
set DIR=XXX
prog
if errorlevel 1 goto err
if not exist XXX\FILENAME goto err
set DIR=
del XXX\FILENAME
rmdir XXX

echo ASSIGN with COB_FILE_PATH
copy /y extensions.53 test.conf > nul
copy /y extensions.54 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
mkdir XX2
set COB_FILE_PATH=XX2
prog
if errorlevel 1 goto err
if not exist XX2\FILENAMEX goto err
set COB_FILE_PATH=
del XX2\FILENAMEX
rmdir XX2

echo NUMBER-OF-CALL-PARAMETERS
copy /y extensions.34 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.35 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
caller > result
if errorlevel 1 goto err
diff extensions.36 result
if errorlevel 1 goto err

echo PROCEDURE DIVISION USING BY ...
copy /y extensions.37 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.38 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
caller > result
if errorlevel 1 goto err
diff extensions.39 result
if errorlevel 1 goto err

echo PROCEDURE DIVISION CHAINING ...
copy /y extensions.40 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog X ABCD > result
if errorlevel 1 goto err
diff extensions.41 result
if errorlevel 1 goto err

echo STOP RUN RETURNING
copy /y extensions.42 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if not errorlevel 1 goto err
if errorlevel 2 goto err
diff prog.empty result
if errorlevel 1 goto err

echo ENTRY
copy /y extensions.43 caller.cob > nul
cobc -x -debug -Wall -std=mvs -c -fstatic-call caller.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y extensions.44 callee.cob > nul
cobc -m -debug -Wall -std=mvs -c -fstatic-call callee.cob > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -o prog caller.obj callee.obj > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.45 result
if errorlevel 1 goto err

echo LINE SEQUENTIAL write
copy /y extensions.46 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff prog.empty result
if errorlevel 1 goto err
if not exist TEST-FILE goto err
diff extensions.47 TEST-FILE
if errorlevel 1 goto err
del TEST-FILE

echo LINE SEQUENTIAL read
copy /y extensions.48 TEST-FILE > nul
copy /y extensions.49 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.50 result
if errorlevel 1 goto err
del TEST-FILE

echo ASSIGN to KEYBOARD/DISPLAY
copy /y extensions.55 TEST-FILE > nul
copy /y extensions.56 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog < TEST-FILE > result
if errorlevel 1 goto err
diff TEST-FILE result
if errorlevel 1 goto err
del TEST-FILE

echo Environment/Argument variable
copy /y extensions.51 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
set TEST_ENV=OK
prog CHECKPAR > result
if errorlevel 1 goto err
diff extensions.52 result
if errorlevel 1 goto err

echo DECIMAL-POINT is COMMA (1)
copy /y extensions.61 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.62 result
if errorlevel 1 goto err

echo DECIMAL-POINT is COMMA (2)
copy /y extensions.63 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.64 result
if errorlevel 1 goto err

echo DECIMAL-POINT is COMMA (3)
copy /y extensions.65 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.66 result
if errorlevel 1 goto err

echo DECIMAL-POINT is COMMA (4)
copy /y extensions.67 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.68 result
if errorlevel 1 goto err

echo DECIMAL-POINT is COMMA (5)
copy /y extensions.69 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.70 result
if errorlevel 1 goto err

echo 78 Level (1)
copy /y extensions.71 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.72 result
if errorlevel 1 goto err

echo 78 Level (2)
copy /y extensions.73 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.74 result
if errorlevel 1 goto err

echo 78 Level (3)
copy /y extensions.75 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff extensions.76 result
if errorlevel 1 goto err

echo Unreachable statement
copy /y extensions.77 prog.cob > nul
cobc -C -x -debug -Wunreachable -std=cobol2002 -o prog prog.cob > comp.out 2>&1
diff extensions.78 comp.out
if errorlevel 1 goto err

echo EXTENSIONS TEST PASSED
del TESTFILE test.conf dump.* caller.* callee.* prog.* result comp.out
goto end

:err
	echo EXTENSIONS TEST FAILED
	pause
:end
