#!/bin/tcsh

setenv COB_LIBRARY_PATH .
echo FUNDAMENTAL TEST GROUP

echo DISPLAY literals
cp fundamental.1 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff fundamental.2 result
if ( $? != 0 ) goto err


echo DISPLAY literals, Decimal Point is COMMA
cp fundamental.3 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff fundamental.4 result
if ( $? != 0 ) goto err

echo Hexadecimal literal
cp fundamental.5 prog.cob
cp fundamental.11 dump.c
c89 -Wc,lp64,dll,xplink,expo -Wl,lp64,dll,xplink -o dump.so dump.c >& comp.out
if ( $? != 0 ) goto err
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff fundamental.6 result
if ( $? != 0 ) goto err

echo DISPLAY data items with VALUE clause
cp fundamental.7 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff fundamental.8 result
if ( $? != 0 ) goto err

echo DISPLAY data items with MOVE statement
cp fundamental.9 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff fundamental.10 result
if ( $? != 0 ) goto err

echo FUNDAMENTAL TEST PASSED
rm -f dump.* prog* result comp.out
goto end

err:
	echo FUNDAMENTAL TEST FAILED
	exit(1)
end:
	exit(0)

