#!/bin/tcsh

echo REF-MOD TEST GROUP

echo Separate sign positions
cp ref-mod.1 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff ref-mod.2 result
if ( $? != 0 ) goto err


echo Static reference modification
cp ref-mod.3 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff ref-mod.4 result
if ( $? != 0 ) goto err

echo Dynamic reference modification
cp ref-mod.5 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff ref-mod.6 result
if ( $? != 0 ) goto err

echo Static out of bounds
cp ref-mod.7 prog.cob
cobc -C -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? == 0 ) goto err
diff ref-mod.8 comp.out
if ( $? != 0 ) goto err

echo Offset underflow
cp ref-mod.9 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog >& result
if ( $? == 0 ) goto err
diff ref-mod.10 result
if ( $? != 0 ) goto err

echo Offset overflow
cp ref-mod.11 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog >& result
if ( $? == 0 ) goto err
diff ref-mod.12 result
if ( $? != 0 ) goto err

echo Length underflow
cp ref-mod.13 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog >& result
if ( $? == 0 ) goto err
diff ref-mod.14 result
if ( $? != 0 ) goto err

echo Length overflow
cp ref-mod.15 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog >& result
if ( $? == 0 ) goto err
diff ref-mod.16 result
if ( $? != 0 ) goto err

echo REF-MOD TEST PASSED
rm prog* result comp.out
goto end

err:
	echo REF-MOD TEST FAILED
	exit(1)
end:
	exit(0)

