#!/bin/tcsh

setenv COB_LIBRARY_PATH .

echo RETURN-CODE moving
cp return-code.1 prog.cob
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 1 ) goto err
diff return-code.2 result
if ( $? != 0 ) goto err

echo RETURN-CODE passing
cp return-code.3 mod1.cob
cp return-code.4 mod2.cob
cp return-code.5 prog.cob
cobc -m -debug -Wall -std=cobol2002 mod1.cob >& comp.out
if ( $? != 0 ) goto err
cobc -m -debug -Wall -std=cobol2002 mod2.cob >& comp.out
if ( $? != 0 ) goto err
cobc -x -debug -Wall -std=cobol2002 prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff return-code.6 result
if ( $? != 0 ) goto err

echo RETURN-CODE TEST PASSED
rm prog* mod1.* mod2.* result comp.out
goto end

err:
	echo RETURN-CODE TEST FAILED
	exit(1)
end:
	exit(0)

