echo COPY: file not found
cp copyb.1 prog.cob
rm -f copy.inc
cobc -x -C -std=cobol2002 -debug -Wall -o prog prog.cob >& comp.out
if ( $? == 0 ) goto err
diff copyb.2 comp.out
if ( $? != 0 ) goto err

echo COPY: replacement order
cp copyb.3 copy.inc
cp copyb.4 prog.cob
cobc -x -std=cobol2002 -debug -Wall -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff copyb.5 result
if ( $? != 0 ) goto err

echo COPY: separators
cp copyb.6 prog.cob
cobc -x -std=cobol2002 -debug -Wall -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff copyb.5 result
if ( $? != 0 ) goto err

echo COPY: partial replacement
cp copyb.7 copy.inc
cp copyb.8 prog.cob
cobc -x -std=cobol2002 -debug -Wall -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff copyb.9 result
if ( $? != 0 ) goto err

echo COPY: recursive replacement
cp copyb.10 copy-2.inc
cp copyb.11 copy-1.inc
cp copyb.12 prog.cob
cobc -x -std=cobol2002 -debug -Wall -o prog prog.cob >& comp.out
if ( $? != 0 ) goto err
prog > result
if ( $? != 0 ) goto err
diff copyb.5 result
if ( $? != 0 ) goto err

echo COPY TEST PASSED
rm prog.* result copy.inc copy-1.inc copy-2.inc comp.out
goto end

err:
	echo COPY TEST FAILED
	exit(1)
end:
	exit(0)

